/***************************************************************************
                          interface.c  -  description
                             -------------------
    begin                : Tue Feb 6 2001
    copyright            : (C) 2001 by Felix Gertz
    email                : felix_gertz@das-fluppt.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <glib.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "statusbar.h"
#include "pronews.h"

const gchar *list_item_data_key="list_item_data";
GtkWidget *statusbar1;
gint statusbar1_context_id;
GtkWidget *entry_akt;
GtkWidget *entry_adr;
GtkWidget *entry_browser;
GtkWidget *checkbutton1;
GtkWidget *config_window;
GtkWidget *clist;

GtkWidget*
create_window2 (void)
{
  GtkWidget *window2;
  GtkWidget *vbox1;
  GtkWidget *handlebox;
  GtkWidget *menubar;
  guint tmp_key;
  GtkWidget *file;
  GtkWidget *file_menu;
  GtkAccelGroup *file_menu_accels;
  GtkWidget *onoff;
  GtkWidget *refresh1;
  GtkWidget *exit_menu;
  GtkWidget *option_menu;
  GtkWidget *settings;
  GtkWidget *settings_menu;
  GtkWidget *about2_menu;
  GtkWidget *about;
  GtkWidget *about_menu;
  GtkAccelGroup *settings_menu_accels;
  GtkWidget *frame1;
  GtkWidget *scrolled_window;
  GtkAccelGroup *accel_group;
  gchar *titles[1] = { "Schlagzeile" };

  accel_group = gtk_accel_group_new ();

  window2 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window2), "window2", window2);
  gtk_widget_set_usize (window2, 350, 320);
  gtk_window_set_title (GTK_WINDOW (window2), "ProNews");

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window2), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window2), vbox1);

  handlebox = gtk_handle_box_new ();
  gtk_widget_ref (handlebox);
  gtk_object_set_data_full (GTK_OBJECT (window2), "handlebox", handlebox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (handlebox);
  gtk_box_pack_start (GTK_BOX (vbox1), handlebox, FALSE, TRUE, 0);

  menubar = gtk_menu_bar_new ();
  gtk_widget_ref (menubar);
  gtk_object_set_data_full (GTK_OBJECT (window2), "menubar", menubar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar);
  gtk_container_add (GTK_CONTAINER (handlebox), menubar);

  file = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (file)->child),
                                   "_File");
  gtk_widget_add_accelerator (file, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (file);
  gtk_object_set_data_full (GTK_OBJECT (window2), "file", file,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file);
  gtk_container_add (GTK_CONTAINER (menubar), file);

  file_menu = gtk_menu_new ();
  gtk_widget_ref (file_menu);
  gtk_object_set_data_full (GTK_OBJECT (window2), "file_menu", file_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (file), file_menu);
  file_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (file_menu));

  onoff = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (onoff)->child),
                                   "_On/Off");
  gtk_widget_add_accelerator (onoff, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (onoff);
  gtk_object_set_data_full (GTK_OBJECT (window2), "onoff", onoff,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (onoff);
  gtk_container_add (GTK_CONTAINER (file_menu), onoff);

  refresh1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (refresh1)->child),
                                   "_Refresh");
  gtk_widget_add_accelerator (refresh1, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (refresh1);
  gtk_object_set_data_full (GTK_OBJECT (window2), "refresh1", refresh1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (refresh1);
  gtk_container_add (GTK_CONTAINER (file_menu), refresh1);
  gtk_signal_connect( GTK_OBJECT( refresh1 ),"activate",GTK_SIGNAL_FUNC( news_refresh ),NULL );

  exit_menu = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (exit_menu)->child),
                                   "E_xit");
  gtk_widget_add_accelerator (exit_menu, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (exit_menu);
  gtk_object_set_data_full (GTK_OBJECT (window2), "exit_menu", exit_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (exit_menu);
  gtk_container_add (GTK_CONTAINER (file_menu), exit_menu);
  gtk_signal_connect( GTK_OBJECT( exit_menu ),"activate",GTK_SIGNAL_FUNC( quit_function ),NULL );

  settings = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (settings)->child),
                                   "_Settings");
  gtk_widget_add_accelerator (settings, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (settings);
  gtk_object_set_data_full (GTK_OBJECT (window2), "settings", settings,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (settings);
  gtk_container_add (GTK_CONTAINER (menubar), settings);

  settings_menu = gtk_menu_new ();
  gtk_widget_ref (settings_menu);
  gtk_object_set_data_full (GTK_OBJECT (window2), "settings_menu", settings_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (settings), settings_menu);
  settings_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (settings_menu));

  option_menu = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (option_menu)->child),
                                   "_Options");
  gtk_widget_add_accelerator (option_menu, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (option_menu);
  gtk_object_set_data_full (GTK_OBJECT (window2), "option_menu", option_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (option_menu);
  gtk_container_add (GTK_CONTAINER (settings_menu), option_menu);
  gtk_signal_connect( GTK_OBJECT( option_menu ),"activate",GTK_SIGNAL_FUNC( open_config_window ),NULL );

  about = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (about)->child),
                                   "_Help");
  gtk_widget_add_accelerator (about, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (about);
  gtk_object_set_data_full (GTK_OBJECT (window2), "about", about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about);
  gtk_container_add (GTK_CONTAINER (menubar), about);

  about_menu = gtk_menu_new ();
  gtk_widget_ref (about_menu);
  gtk_object_set_data_full (GTK_OBJECT (window2), "about_menu", about_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (about), about_menu);
  settings_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (about_menu));

  about2_menu = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (about2_menu)->child),
                                   "_About");
  gtk_widget_add_accelerator (about2_menu, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (about2_menu);
  gtk_object_set_data_full (GTK_OBJECT (window2), "about2_menu", about2_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about2_menu);
  gtk_container_add (GTK_CONTAINER (about_menu), about2_menu);
  gtk_signal_connect( GTK_OBJECT( about2_menu ),"activate",GTK_SIGNAL_FUNC( open_about_window ),NULL );

  frame1 = gtk_frame_new (NULL);
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (window2), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);


  scrolled_window=gtk_scrolled_window_new(NULL, NULL);
  gtk_container_add(GTK_CONTAINER(frame1), scrolled_window);
  gtk_widget_show(scrolled_window);

	clist = gtk_clist_new_with_titles( 1, titles);
	gtk_signal_connect(GTK_OBJECT(clist), "select_row",GTK_SIGNAL_FUNC(selection_made),NULL);
	gtk_container_add(GTK_CONTAINER(scrolled_window), clist);
  gtk_widget_show(clist);
  fill_clist();

  statusbar1 = gtk_statusbar_new ();
  gtk_widget_show (statusbar1);
  statusbar1_context_id = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar1), "Statusbar1");
  gtk_box_pack_start (GTK_BOX (vbox1), statusbar1, FALSE, FALSE, 1);

  gtk_signal_connect (GTK_OBJECT (onoff), "activate",
                      GTK_SIGNAL_FUNC (on_onoff_activate),
                      NULL);
 /* gtk_signal_connect (GTK_OBJECT (refresh1), "activate",
                      GTK_SIGNAL_FUNC (on_refresh1_activate),
                      NULL);*/

  gtk_window_add_accel_group (GTK_WINDOW (window2), accel_group);

  gtk_signal_connect( GTK_OBJECT( window2 ),"delete_event",GTK_SIGNAL_FUNC( quit_function ),NULL );
  gtk_signal_connect( GTK_OBJECT( window2 ),"destroy",GTK_SIGNAL_FUNC( quit_function ),NULL );

  return window2;
}

GtkWidget*
create_window1 (char titel[],char label[])
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *button1;

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_widget_set_usize (window1, 200, 65);
  gtk_window_set_title (GTK_WINDOW (window1), titel);
  gtk_window_set_position (GTK_WINDOW (window1), GTK_WIN_POS_MOUSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  label1 = gtk_label_new (label);
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label1), 0, 10);

  button1 = gtk_button_new_with_label ("OK");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_signal_connect( GTK_OBJECT( button1 ),"clicked",GTK_SIGNAL_FUNC( widget_destroy ),window1 );
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (vbox1), button1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button1), 2);

  g_print("\a");

  return window1;
}

GtkWidget*
create_config_window (void)
{
  GtkWidget *table1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *button2;
  GtkWidget *button1;

  char akt_buffer[10];

  config_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (config_window), "config_window", config_window);
  gtk_window_set_title (GTK_WINDOW (config_window), "ProNews - Options");
  gtk_window_set_position (GTK_WINDOW (config_window), GTK_WIN_POS_MOUSE);

  table1 = gtk_table_new (5, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (config_window), table1);
  gtk_table_set_row_spacings (GTK_TABLE (table1), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 5);

  label1 = gtk_label_new ("Online starten?");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_table_attach (GTK_TABLE (table1), label1, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label1), 10, 0);

  label2 = gtk_label_new ("Aktualisierungsrate in s:");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_table_attach (GTK_TABLE (table1), label2, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label2), 10, 0);

  label3 = gtk_label_new ("Adresse vom Newsfile:");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_table_attach (GTK_TABLE (table1), label3, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label3), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label3), 10, 0);

  label4 = gtk_label_new ("Browser:");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_table_attach (GTK_TABLE (table1), label4, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label4), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label4), 10, 0);

  entry_akt = gtk_entry_new ();
  gtk_widget_ref (entry_akt);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "entry_akt", entry_akt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_akt);
  gtk_table_attach (GTK_TABLE (table1), entry_akt, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 8, 0);
  sprintf(akt_buffer,"%d",akt_rate);
  gtk_entry_set_text (GTK_ENTRY (entry_akt), akt_buffer);

  entry_adr = gtk_entry_new_with_max_length (255);
  gtk_widget_ref (entry_adr);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "entry_adr", entry_adr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_adr);
  gtk_table_attach (GTK_TABLE (table1), entry_adr, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 8, 0);
	gtk_entry_set_text (GTK_ENTRY (entry_adr), newsfile_path);

  entry_browser = gtk_entry_new_with_max_length (255);
  gtk_widget_ref (entry_browser);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "entry_browser", entry_browser,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_browser);
  gtk_table_attach (GTK_TABLE (table1), entry_browser, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 8, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_browser), browser_file);

  button2 = gtk_button_new_with_label ("OK");
  gtk_widget_ref (button2);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "button2", button2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button2);
  gtk_table_attach (GTK_TABLE (table1), button2, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 27, 0);
  gtk_signal_connect( GTK_OBJECT( button2 ),"clicked",GTK_SIGNAL_FUNC( set_new_config ),NULL );

  button1 = gtk_button_new_with_label ("Defaults");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_table_attach (GTK_TABLE (table1), button1, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 9, 0);
  gtk_signal_connect( GTK_OBJECT( button1 ),"clicked",GTK_SIGNAL_FUNC( get_config_defaults ),NULL );

  checkbutton1 = gtk_check_button_new_with_label ("");
  gtk_widget_ref (checkbutton1);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "checkbutton1", checkbutton1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton1);
  gtk_table_attach (GTK_TABLE (table1), checkbutton1, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 8, 0);
  if(!onoff_status_default) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton1),FALSE);
	else gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton1),TRUE);

  return config_window;
}

GtkWidget*
create_about_window (void)
{
  GtkWidget *about_window;
  GtkWidget *vbox1;
  GtkWidget *pixmap1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *button1;
  char buffer[50]="ProNews ";

  about_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (about_window), "about_window", about_window);
  gtk_window_set_title (GTK_WINDOW (about_window), "ProNews - About");

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (about_window), vbox1);

  pixmap1 = create_pixmap (about_window, "pronews.xpm");
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (vbox1), pixmap1, FALSE, TRUE, 0);

	strcat(buffer,VERSION);

  label1 = gtk_label_new ("label1");
  gtk_label_parse_uline(GTK_LABEL(label1),buffer);
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 13);

  label2 = gtk_label_new ("");
  gtk_label_parse_uline (GTK_LABEL (label2),
                         "geschrieben von Felix Gertz\nE-Mail: felix__gertz@das-fluppt.de\nhttp://gtkpronews.sourceforge.net\nLicense: GPL\n\nProgramm enthaellt die \"Tiny Http-lib\"\nvon Laurent Demailly\nLicense: Artistic");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (vbox1), label2, TRUE, FALSE, 0);

  button1 = gtk_button_new_with_label ("OK");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (vbox1), button1, FALSE, FALSE, 10);
  gtk_signal_connect( GTK_OBJECT( button1 ),"clicked",GTK_SIGNAL_FUNC( widget_destroy ),about_window );

  return about_window;
}

